// Generated by CoffeeScript 1.6.3
(function() {
  var Evaluation, Monitor, Result;

  Monitor = require('./Monitor');

  Result = require('./Result');

  /*
  Internal class that wraps an evaluation
  */


  module.exports = Evaluation = (function() {
    function Evaluation(func) {
      this.func = func;
    }

    Evaluation.prototype.run = function() {
      var e, _ref, _ref1;
      try {
        return new Result({
          result: this.func(),
          monitor: (_ref = this.m) != null ? _ref.public_api : void 0
        });
      } catch (_error) {
        e = _error;
        return new Result({
          error: e,
          monitor: (_ref1 = this.m) != null ? _ref1.public_api : void 0
        });
      } finally {
        delete this.func;
        delete this.m;
      }
    };

    /*
    An evaluation owns a monitor
    */


    Evaluation.prototype.monitor = function() {
      return this.m != null ? this.m : this.m = new Monitor;
    };

    /*
    You can request N notifiers
    ( they will be provisioned by the current monitor )
    */


    Evaluation.prototype.notifier = function() {
      var _ref;
      return (_ref = this.monitor().evaluation$create_notifier()) != null ? _ref.public_api : void 0;
    };

    return Evaluation;

  })();

}).call(this);
