// Generated by CoffeeScript 1.6.3
(function() {
  var Base, Monitor, Notifier, util,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  Notifier = require('./Notifier');

  Base = require('./Base');

  util = require('./util');

  module.exports = Monitor = (function(_super) {
    __extends(Monitor, _super);

    Monitor.prototype.states = {
      ready: null,
      changed: 'handle_change',
      cancelled: 'handle_cancel'
    };

    Monitor.prototype.cancelled_notifiers = 0;

    function Monitor() {
      this.user$cancel = __bind(this.user$cancel, this);
      this.notifier$cancel_notifier = __bind(this.notifier$cancel_notifier, this);
      this.evaluation$create_notifier = __bind(this.evaluation$create_notifier, this);
      var f,
        _this = this;
      this.notifiers = [];
      this.public_api = f = function(h) {
        return _this.once('change', h);
      };
      util.copy_event_emitter_methods(this, f);
      f.cancel = function() {
        return _this.user$cancel();
      };
      f.state = function() {
        return _this.state;
      };
    }

    Monitor.prototype.handle_cancel = function() {
      this.emit('cancel');
      return this.emit('destroy');
    };

    Monitor.prototype.handle_change = function() {
      this.emit('change');
      return this.emit('destroy');
    };

    Monitor.prototype.evaluation$create_notifier = function() {
      var n;
      this.notifiers.push(n = new Notifier(this));
      return n;
    };

    Monitor.prototype.notifier$cancel_notifier = function() {
      if (this.notifiers.length === ++this.cancelled_notifiers) {
        return this.transition('cancelled');
      }
    };

    Monitor.prototype.notifier$change = function() {
      var _this = this;
      return this.transition('changed', function() {
        var x, _i, _len, _ref, _results;
        _ref = _this.notifiers;
        _results = [];
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          x = _ref[_i];
          if (x.state === 'ready') {
            _results.push(x.monitor$cancel());
          }
        }
        return _results;
      });
    };

    Monitor.prototype.user$cancel = function() {
      var _this = this;
      return this.transition('cancelled', function() {
        var x, _i, _len, _ref, _results;
        _ref = _this.notifiers;
        _results = [];
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          x = _ref[_i];
          if (x.state === 'ready') {
            _results.push(x.monitor$cancel());
          }
        }
        return _results;
      });
    };

    return Monitor;

  })(Base);

}).call(this);
