// Generated by CoffeeScript 1.6.3
(function() {
  var GLOBAL, build, conditional_build, core, util, version, _poll, _subscribe;

  core = require('./core');

  _poll = require('./poll');

  _subscribe = require('./subscribe');

  version = require('./version');

  util = require('./util');

  /*
  Main entry point to the reactivity framework.
  Exports an object that exposes the 5 API methods.
  The object is itself an overloaded function that proxies
  to the methods for convenience.
  */


  build = function() {
    var active, main, notifier, poll, run, subscribe, _c, _ref;
    _ref = _c = core(), notifier = _ref.notifier, active = _ref.active, run = _ref.run;
    subscribe = _subscribe(_c);
    poll = _poll(_c);
    main = function(x, y) {
      switch (typeof x + ' ' + typeof y) {
        case 'undefined undefined':
          return notifier();
        case 'function undefined':
          return run(x);
        case 'function function':
          return subscribe(x, y);
        case 'function number':
          return poll(x, y);
        case 'number function':
          return poll(y, x);
        default:
          throw new Error('Invalid Arguments');
      }
    };
    main.notifier = notifier;
    main.active = active;
    main.run = run;
    main.subscribe = subscribe;
    main.poll = poll;
    main.version = version;
    return main;
  };

  GLOBAL = global || window;

  (conditional_build = function() {
    var create, other, other_version;
    create = false;
    if ((other = GLOBAL.reactivity) != null) {
      other_version = other.version || '0.0.0';
      if (util.compare_semver(version, other_version) === 'GT') {
        create = true;
      }
    } else {
      create = true;
    }
    if (create) {
      return GLOBAL.reactivity = build();
    }
  })();

  module.exports = GLOBAL.reactivity;

}).call(this);
